package jp.denpa.tomy.opengl_es.wrap;


import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLSurfaceView;
import android.opengl.GLUtils;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import jp.denpa.tomy.games.MyView;
import jp.denpa.tomy.games.R;


//OpenGL の　Rendererに関するクラス　メインループもここでする（←？）

public class MainRenderer implements GLSurfaceView.Renderer{

	private GL2DVertex test = new GL2DVertex();
	private GL2DVertex test2 = new GL2DVertex();
	private GLTexture  tex1  = new GLTexture();
	private GLTexture  tex2  = new GLTexture();


	enum FlameNo{
		START_INIT,
		START_MAIN,
		MENU_INIT,   	//メニュー準備
		MENU_MAIN,   	//メニュー処理
		GAME_INIT,   	//ゲーム準備
		GAME_MAIN,		//ゲーム処理
		RESULT_INIT,	//ゲーム終了時の得点表示
		RESULT_MAIN,	//ゲーム終了時の得点表示
	}


	private Context context;


	static FlameNo gameFlg = FlameNo.START_INIT;        //ゲームフラグ

	static int screenW;           //スクリーン座標
	static int screenH;




	public  MainRenderer(Context ctext){

		context=ctext;
	}

	private int textureName;


	//サーフェイス作成時の処理(サーフェイスが生成される際・または再生成される際に呼ばれる)
	@Override
	public void onSurfaceCreated(GL10 gl10, EGLConfig eglconfing){
		//⑦背景色
		gl10.glClearColor(1.0f,1.0f,1.0f,1.0f);
	    // ディザを無効化
	    gl10.glDisable(GL10.GL_DITHER);
	    // 深度テストを有効に
	    gl10.glEnable(GL10.GL_DEPTH_TEST);
	 	//テクスチャ機能ON
//	  	gl10.glEnable(GL10.GL_TEXTURE_2D);
	    //透明可能に
	  	gl10.glEnable(GL10.GL_ALPHA_TEST);
	   	//ブレンド可能に
	   	gl10.glEnable(GL10.GL_BLEND);
	  	//色のブレンド方法
	  	gl10.glBlendFunc(GL10.GL_SRC_ALPHA,GL10.GL_ONE_MINUS_SRC_ALPHA);
	}

	//画面上のどの領域を使用するかの設定、あとポリゴン色とかの設定(サーフェイスのサイズ変更時に呼ばれる)
	@Override
	public void onSurfaceChanged(GL10 gl10, int w,int h ){
		gl10.glViewport(0, 0, w, h);
		screenW = w;
		screenH = h;

		//テクスチャに関する処理---------------------------------------
//		Bitmap bitmap =	BitmapFactory.decodeResource(context.getResources(), R.drawable.image_512);
//
//        log("bitmap size : " + bitmap.getWidth() + " x " + bitmap.getHeight());
//		gl10.glEnable(GL10.GL_TEXTURE_2D);
//		int[] buffers = new int[1];
//		//texture夜のメモリを指定数確保
//		gl10.glGenTextures(1,buffers,0);
//		//テクスチャ名を保存する
//		textureName = buffers[0];
//
//		gl10.glBindTexture(GL10.GL_TEXTURE_2D, textureName);
//		GLUtils.texImage2D(GL10.GL_TEXTURE_2D, 0, bitmap, 0);
//
//		//拡大縮小時の処理を指定
//		gl10.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, GL10.GL_NEAREST);
//		gl10.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, GL10.GL_NEAREST);
//
//		//ビットマップを廃棄
//		bitmap.recycle();

	}



	//毎フレーム描画処理
	@Override
	public void onDrawFrame(GL10 gl10){

		//背景塗りつぶし----------------------------------
		gl10.glClearColor(0.0f, 0.5f, 0.5f, 1.0f);
		gl10.glClear(GL10.GL_COLOR_BUFFER_BIT);
		//end---------------------------------------------

		tex1.LoadTexture(gl10, context.getResources(), R.drawable.image_512);
		tex2.LoadTexture(gl10, context.getResources(), R.drawable.image_128);


		test.center=new Vector2(50,50);
		test.size=new Vector2(100,100);
		test.Init(gl10);
		//test.SetUV(2, 2, 1, 1, false);		//成功


		test.SetPos();
		test.Draw(tex2);


		test2.center=new Vector2(300,300);
		test2.size=new Vector2(100,100);
		test2.Init(gl10);
		test2.SetUV(2, 2, 1, 0, false);		//成功

		test2.SetPos();
		test2.Draw(null);

	}
}

